/*
PROJETO: Game OPENGL "Batalha Naval"
Author	: Roger Larico Chavez
RA		: 022693

  FEEC UNICAMP
*/
#include "stdafx.h"//tirar se esta en linux

#include "glut.h"
#include "stdlib.h"
#include "stdio.h"

#define sizeItem 4.5
#define N 10


#include "structs.h"
#include "models.h" 

#define COLOR /255
#define PI 3.1415

#define COORD_TEXTURA_PLANO 1.0
#define COORD_TEXTURA_AVIAO 1.0
#define COR_DO_PLANO 0.52,0.52,0.78,1.0
#define COR_DO_AVIAO 0.3,0.52,0.18,1.0
#define TEXTURA_DO_PLANO "agua1.rgb"
#define TEXTURA_DO_AVIAO "camuflagem2.rgb"

GLint WIDTH =800;
GLint HEIGHT=600;

//GLfloat obs[3]={0.0,7.0,0.0};
//GLfloat look[3]={0.0,3.0,0.0};
GLuint  textura_plano;
GLuint  textura_aviao;

GLshort texturas=1;
GLfloat tetaxz=0;
GLfloat raioxz=6;

GLfloat ctp[4][2]={
  {-COORD_TEXTURA_PLANO,-COORD_TEXTURA_PLANO},
  {+COORD_TEXTURA_PLANO,-COORD_TEXTURA_PLANO},
  {+COORD_TEXTURA_PLANO,+COORD_TEXTURA_PLANO},
  {-COORD_TEXTURA_PLANO,+COORD_TEXTURA_PLANO}
};

GLfloat cta[4][2]={
  {-COORD_TEXTURA_AVIAO,-COORD_TEXTURA_AVIAO},
  {+COORD_TEXTURA_AVIAO,-COORD_TEXTURA_AVIAO},
  {+COORD_TEXTURA_AVIAO,+COORD_TEXTURA_AVIAO},
  {-COORD_TEXTURA_AVIAO,+COORD_TEXTURA_AVIAO}
};



typedef struct{
  unsigned short imagic;
  unsigned short type;
  unsigned short dim;
  unsigned short sizeX, sizeY, sizeZ;
  char name[128];
  unsigned char *data;
} IMAGE;

IMAGE *ImageLoad(char *);
#define IMAGIC      0x01da
#define IMAGIC_SWAP 0xda01

#define SWAP_SHORT_BYTES(x) ((((x) & 0xff) << 8) | (((x) & 0xff00) >> 8))
#define SWAP_LONG_BYTES(x) (((((x) & 0xff) << 24) | (((x) & 0xff00) << 8)) | \
((((x) & 0xff0000) >> 8) | (((x) & 0xff000000) >> 24)))

typedef struct{
  unsigned short imagic;
  unsigned short type;
  unsigned short dim;
  unsigned short sizeX, sizeY, sizeZ;
  unsigned long min, max;
  unsigned long wasteBytes;
  char name[80];
  unsigned long colorMap;
  FILE *file;
  unsigned char *tmp[5];
  unsigned long rleEnd;
  unsigned long *rowStart;
  unsigned long *rowSize;
} Image;


static Image *ImageOpen(char *fileName){
  Image *image;
  unsigned long *rowStart, *rowSize, ulTmp;
  int x, i;

  image = (Image *)malloc(sizeof(Image));
  if (image == NULL){
    fprintf(stderr, "Out of memory!\n");
    exit(-1);
  }
  if ((image->file = fopen(fileName, "rb")) == NULL){
    perror(fileName);
    exit(-1);
  }
  /*
   *	Read the image header
   */
  fread(image, 1, 12, image->file);
  /*
   *	Check byte order
   */
  if (image->imagic == IMAGIC_SWAP){
    image->type = SWAP_SHORT_BYTES(image->type);
    image->dim = SWAP_SHORT_BYTES(image->dim);
    image->sizeX = SWAP_SHORT_BYTES(image->sizeX);
    image->sizeY = SWAP_SHORT_BYTES(image->sizeY);
    image->sizeZ = SWAP_SHORT_BYTES(image->sizeZ);
  }

  for ( i = 0 ; i <= image->sizeZ ; i++ ){
    image->tmp[i] = (unsigned char *)malloc(image->sizeX*256);
    if (image->tmp[i] == NULL ) {
      fprintf(stderr, "Out of memory!\n");
      exit(-1);
    }
  }

  if ((image->type & 0xFF00) == 0x0100){ /* RLE image */
    x = image->sizeY * image->sizeZ * sizeof(long);
    image->rowStart = (unsigned long *)malloc(x);
    image->rowSize = (unsigned long *)malloc(x);
    if (image->rowStart == NULL || image->rowSize == NULL){
      fprintf(stderr, "Out of memory!\n");
      exit(-1);
    }
    image->rleEnd = 512 + (2 * x);
    fseek(image->file, 512, SEEK_SET);
    fread(image->rowStart, 1, x, image->file);
    fread(image->rowSize, 1, x, image->file);
    if (image->imagic == IMAGIC_SWAP){
      x /= sizeof(long);
      rowStart = image->rowStart;
      rowSize = image->rowSize;
      while (x--){
	ulTmp = *rowStart;
	*rowStart++ = SWAP_LONG_BYTES(ulTmp);
	ulTmp = *rowSize;
	*rowSize++ = SWAP_LONG_BYTES(ulTmp);
      }
    }
  }
  return image;
}

static void ImageClose( Image *image){
  int i;

  fclose(image->file);
  for ( i = 0 ; i <= image->sizeZ ; i++ )
    free(image->tmp[i]);
  free(image);
}

static void ImageGetRow( Image *image, unsigned char *buf, int y, int z){
  unsigned char *iPtr, *oPtr, pixel;
  int count;

  if ((image->type & 0xFF00) == 0x0100){  /* RLE image */
    fseek(image->file, image->rowStart[y+z*image->sizeY], SEEK_SET);
    fread(image->tmp[0], 1, (unsigned int)image->rowSize[y+z*image->sizeY],
	  image->file);

    iPtr = image->tmp[0];
    oPtr = buf;
    while (1){
      pixel = *iPtr++;
      count = (int)(pixel & 0x7F);
      if (!count)
	return;
      if (pixel & 0x80){
	while (count--){
	  *oPtr++ = *iPtr++;
	}
      } 
      else{
	pixel = *iPtr++;
	while (count--){
	  *oPtr++ = pixel;
	}
      }
    }
  }
  else{ /* verbatim image */
    fseek(image->file, 512+(y*image->sizeX)+(z*image->sizeX*image->sizeY),
	  SEEK_SET);
    fread(buf, 1, image->sizeX, image->file);
  }
}

static void ImageGetRawData( Image *image, char *data)
{
  int i, j, k;
  int remain;

  switch ( image->sizeZ ){
  case 1:
    remain = image->sizeX % 4;
    break;
  case 2:
    remain = image->sizeX % 2;
    break;
  case 3:
    remain = (image->sizeX * 3) & 0x3;
    if (remain)
      remain = 4 - remain;
    break;
  case 4:
    remain = 0;
    break;
  }

  for (i = 0; i < image->sizeY; i++) {
    for ( k = 0; k < image->sizeZ ; k++ )
      ImageGetRow(image, image->tmp[k+1], i, k);
    for (j = 0; j < image->sizeX; j++) 
      for ( k = 1; k <= image->sizeZ ; k++ )
	*data++ = *(image->tmp[k] + j);
    data += remain;
  }
}

IMAGE *ImageLoad(char *fileName)
{
  Image *image;
  IMAGE *final;
  int sx;

  image = ImageOpen(fileName);

  final = (IMAGE *)malloc(sizeof(IMAGE));
  if (final == NULL){
    fprintf(stderr, "Out of memory!\n");
    exit(-1);
  }
  final->imagic = image->imagic;
  final->type = image->type;
  final->dim = image->dim;
  final->sizeX = image->sizeX; 
  final->sizeY = image->sizeY;
  final->sizeZ = image->sizeZ;

  /* 
   * Round up so rows are long-word aligned 
   */
  sx = ( (image->sizeX) * (image->sizeZ) + 3) >> 2;

  final->data 
    = (unsigned char *)malloc( sx * image->sizeY * sizeof(unsigned int));

  if (final->data == NULL){
    fprintf(stderr, "Out of memory!\n");
    exit(-1);
  }

ImageGetRawData(image, (char *)final->data);
ImageClose(image);
return final;
}

#define LENGTH_MAX_PATH 256
float W1,H1;
int X,Y;

void Fire(int i,int j);
void TransXY(int item, int NroItem);
void DisplayMain(void);
void ReShape (int w, int h);

// La estructura de una seleccion
typedef struct
{
	GLuint Identifiers[LENGTH_MAX_PATH];
	int NIdentifiers;
	GLuint Zmin,Zmax;
} Path;

//float angle, angle2,angle3;

int moving, startx, starty;
float initSC= N*sizeItem/2;

GLfloat  ambient_light[] = { 0.2, 0.2, 0.2, 1.0}; 
GLfloat   source_light[] = { 1.0, 1.0, 1.0, 1.0}; 
GLfloat     spec_light[] = { 1.0, 1.0, 1.0, 1.0};
GLfloat      light_pos[] = { 0, 25, 0, 1};//pontual

GLfloat  ambient_light_n []	= { 0.0, 0.0, 0.0, 1.0 }; 
GLfloat   source_light_n []	= { 0.2, 0.2, 0.2, 1.0 }; 
GLfloat     spec_light_n []	= { 1.0, 1.0, 1.0, 1.0};


void TransXY(int item, int NroItem)
{
	int x,y;
		for(int i=0;i<NroItem;i++)
		{
			if(item<((i+1)*10))
			{
				x=item-(i*10);	
				y=i;
				break;
			}
		}	
	X=x;
	Y=y;
}

void DrawItem(int Lin, int Col, GLenum RenderType)
// Identifier indica el identificador que hay que dar al objeto, si 
// estamos en modo de seleccion
// RenderType indica si vamos a buscar una seleccion (==GL_SELECT)
// o vamos a dibujar el objeto (==GL_RENDER)
{
	int Identifier=Lin+10*Col;
	GLUquadricObj *Item = gluNewQuadric();

	// Si estamos en modo seleccion, indicamos el identificador 
	// de la esfera
	
	
	if(RenderType == GL_SELECT)
		glPushName(Identifier);

	glPushMatrix();

	//glRotatef(-55, 1, 0, 0);  
	//glRotatef(2, 0, 1, 0);  


	    glTranslatef(-6.2,6.2,0.0);
		
		glTranslatef(Lin*1.36,-Col*1.36,-10);
		//glTranslatef(Lin*4.5,-Col*4.5,-10);
		glColor3f(0.0,0.0,1.0);	
		glScalef(1,1,0.1);
		glPolygonMode(GL_FRONT_AND_BACK, GL_LINE);		
		glutSolidCube(sizeItem*0.29);
		glPolygonMode(GL_FRONT_AND_BACK, GL_FILL );				 

		// Sacamos el idenficador de la pila
		if(RenderType == GL_SELECT)
			glPopName();

	glPopMatrix();
	
	gluDeleteQuadric(Item);
}

void DrawScene(GLenum RenderType)
// Dibuja la escena
// RenderType indica si vamos a buscar una seleccion (==GL_SELECT)
// o vamos a dibujar el objeto (==GL_RENDER)
{
	int i,j;
	for(i=0;i<N;i++)
	{
		for(j=0;j<N;j++)
			DrawItem(i,j,RenderType);
	}	
}

int GetSelection(int x, int y, Path *Selected)
// Devuelve 0 si no se ha encontrado ninguna seleccion
// Devuelve 1 si se ha encontrado alguna, y mete su valor en Selected
{
	GLuint SelectionBuffer[LENGTH_MAX_PATH];
	GLint ViewportCoordinates[4];
	int NObjectsSelected;
	Path SelectedPath, CurrentPath;
	GLuint z1,z2,Identifier;
	int IndexBuffer;

	// Inicializamos el modo de seleccion
	glSelectBuffer(LENGTH_MAX_PATH,SelectionBuffer);
	glRenderMode(GL_SELECT);
	glInitNames();

	// Obtenemos las coordenadas actuales del Viewport
	glGetIntegerv(GL_VIEWPORT,ViewportCoordinates);

	glMatrixMode(GL_PROJECTION);
	glPushMatrix();
		// Creamos un volumen de seleccion, centrado en el punto donde
		// se pincho el raton (x,y) y con una sensibilidad de 5x5 pixels
		glLoadIdentity();
		gluPickMatrix( (GLdouble)x, (GLdouble) (ViewportCoordinates[3] - y),5.0,5.0,ViewportCoordinates);
		gluPerspective(60.0, W1/H1, 1.0, 100.0);
		//glOrtho(-8.0,8.0,-8.0,8.0,0.0,20.0);
		// Redibujamos la escena
		DrawScene(GL_SELECT);
	glPopMatrix();
	glFlush();

	// Ahora procesamos las selecciones detectadas
	NObjectsSelected = glRenderMode(GL_RENDER);
	printf("\nNumero de objetos : %i\n",NObjectsSelected);

	IndexBuffer = 0;
	SelectedPath.Zmax = 0;
	for(int i=0;i<NObjectsSelected; i++)
	{
		// Obtenemos los valores de la seleccion que vamos a estudiar
		CurrentPath.NIdentifiers =  SelectionBuffer[IndexBuffer++];
		CurrentPath.Zmin = SelectionBuffer[IndexBuffer++];
		CurrentPath.Zmax = SelectionBuffer[IndexBuffer++];
		for(int j=0;j<CurrentPath.NIdentifiers;j++)
			CurrentPath.Identifiers[j] = SelectionBuffer[IndexBuffer++];

		// los zi dan una medida de lo cerca o lejos que estan los puntos pinchados del objeto
		// z2 es el punto mas cercano a la pantalla.
		// z1 el mas lejano.
		// Si hay dos objetos superpuestos, con z2 podemos decidir cual de ellos
		// es el realmente seleccionado.
		if(CurrentPath.Zmax > SelectedPath.Zmax)
			SelectedPath = CurrentPath;
	}
	if(NObjectsSelected>0)
	{
		*Selected = SelectedPath;
		return 1;
	}
	else
		return 0;
}

void Mouse(int button, int state, int x, int y)
{
 if(state)
 {
	
	Path SelectedPath;
	int Seleccionado=0;

	Seleccionado = GetSelection(x,y,&SelectedPath);
	if(Seleccionado)
	{	TransXY(SelectedPath.Identifiers[SelectedPath.NIdentifiers-1],N);
		printf("MOUSE: objeto escolhido : %i  (x,y) = (%i ,%i)\n",SelectedPath.Identifiers[SelectedPath.NIdentifiers-1],X,Y);
		Fire(Y,X);
		glutPostRedisplay();	
	}else
	{
		X=-1;Y=-1;
	}
 }
}

void ResizeWindow(GLsizei w, GLsizei h)
{
	
	W1=w;H1=h;
	
	//glViewport(0,0,w,h);
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	gluPerspective(60.0, (GLfloat)w/(GLfloat)h, 1.0, 100.0);
	//glOrtho(-8.0,8.0,-8.0,8.0,0.0,20.0);
	glMatrixMode(GL_MODELVIEW);
	//glLoadIdentity();
	
	//ReShape(w,h);
}

void RedrawWindow(void)
{
	glClearDepth(1.0);
    glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
	DisplayMain();
	DrawScene(GL_RENDER);
	
	glFlush();
	glutSwapBuffers();
}

/*
void Mouse ( int button, int state, int x, int y )
{
   if ( button == GLUT_LEFT_BUTTON && state == GLUT_DOWN )
   {
      moving = 1;
      startx = x;
      starty = y;
   }

   if ( button == GLUT_LEFT_BUTTON && state == GLUT_UP  )
      moving = 0;
   	printf("mouse (x,y)->(%i , %i)\n",x,y);
}
/**/
void Motion ( int x, int y )
{
   if ( moving )
   {
      Scene.gliRotY= Scene.gliRotY+   ( x - startx )*0.01;
      Scene.gliRotX = Scene.gliRotX+ ( y - starty )*0.01;
      startx = x;
      starty = y;
      glutPostRedisplay ( );
   }
   
}

void initNave(char *filePath)
{
	
	FILE *stream;
	stream = fopen( filePath, "r" );
	fseek( stream, 0L, SEEK_SET );

	fscanf( stream, "%i", &NaveA.position[0][0]);	fscanf( stream, "%i", &NaveA.position[0][1]);
	fscanf( stream, "%i", &NaveA.position[1][0]);	fscanf( stream, "%i", &NaveA.position[1][1]);

	fscanf( stream, "%i", &NaveB.position[0][0]);	fscanf( stream, "%i", &NaveB.position[0][1]);
	fscanf( stream, "%i", &NaveB.position[1][0]);	fscanf( stream, "%i", &NaveB.position[1][1]);
	fscanf( stream, "%i", &NaveB.position[2][0]);	fscanf( stream, "%i", &NaveB.position[2][1]);

	fscanf( stream, "%i",&NaveC.position[0][0]);	fscanf( stream, "%i",&NaveC.position[0][1]);
	fscanf( stream, "%i",&NaveC.position[1][0]);	fscanf( stream, "%i",&NaveC.position[1][1]);
	fscanf( stream, "%i",&NaveC.position[2][0]);	fscanf( stream, "%i",&NaveC.position[2][1]);
	fscanf( stream, "%i",&NaveC.position[3][0]);	fscanf( stream, "%i",&NaveC.position[3][1]);

	fclose(stream);
}

void carregar_texturas(void)
{
  IMAGE *img;
  GLenum gluerr;

  /* textura do plano */
  glGenTextures(1, &textura_plano);
  glBindTexture(GL_TEXTURE_2D, textura_plano);
  
  if(!(img=ImageLoad(TEXTURA_DO_PLANO))) {
    fprintf(stderr,"Error reading a texture.\n");
    exit(-1);
  }

  gluerr=gluBuild2DMipmaps(GL_TEXTURE_2D, 3, 
			   img->sizeX, img->sizeY, 
			   GL_RGB, GL_UNSIGNED_BYTE, 
			   (GLvoid *)(img->data));
  if(gluerr){
    fprintf(stderr,"GLULib%s\n",gluErrorString(gluerr));
    exit(-1);
  }

  glTexParameterf(GL_TEXTURE_2D,GL_TEXTURE_WRAP_S,GL_REPEAT);
  glTexParameterf(GL_TEXTURE_2D,GL_TEXTURE_WRAP_T,GL_REPEAT);
  glTexParameterf(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR_MIPMAP_LINEAR);
  glTexParameterf(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR);
  glTexEnvf(GL_TEXTURE_ENV,GL_TEXTURE_ENV_MODE,GL_DECAL);

  /* textura do aviao */
  glGenTextures(1, &textura_aviao);
  glBindTexture(GL_TEXTURE_2D, textura_aviao);

  
  if(!(img=ImageLoad(TEXTURA_DO_AVIAO))) {
    fprintf(stderr,"Error reading a texture.\n");
    exit(-1);
  }

  gluerr=gluBuild2DMipmaps(GL_TEXTURE_2D, 3, 
			   img->sizeX, img->sizeY, 
			   GL_RGB, GL_UNSIGNED_BYTE, 
			   (GLvoid *)(img->data));
  if(gluerr){
    fprintf(stderr,"GLULib%s\n",gluErrorString(gluerr));
    exit(-1);
  }

  glTexParameterf(GL_TEXTURE_2D,GL_TEXTURE_WRAP_S,GL_REPEAT);
  glTexParameterf(GL_TEXTURE_2D,GL_TEXTURE_WRAP_T,GL_REPEAT);
  glTexParameterf(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR_MIPMAP_LINEAR);
  glTexParameterf(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR);
  glTexEnvf(GL_TEXTURE_ENV,GL_TEXTURE_ENV_MODE,GL_DECAL);
  
}

void init(void)
{
//	carregar_texturas();

	glutInitDisplayMode (GLUT_DOUBLE | GLUT_RGB);
	glutInitWindowSize (600, 400);
	glutInitWindowPosition (200, 0);
	glutCreateWindow ("Control Table -BATALHA NAVAL 0.3 ");	

	glClearColor(0.0,0.0,0.0,0.0);
	glDepthFunc(GL_LEQUAL);
	glEnable(GL_DEPTH_TEST);
	glShadeModel(GL_FLAT);


	//glutInitDisplayMode (GLUT_DOUBLE | GLUT_RGB);
	//glutInitWindowSize (600, 400);
	//glutInitWindowPosition (200, 0);
	//glutCreateWindow ("BATALHA NAVAL 0.3");
	//glClearColor (1.0, 1.0, 1.0, 1.0); //fundo branco
	//glPolygonMode(GL_FRONT_AND_BACK, GL_LINE); //wireframe
	glShadeModel (GL_SMOOTH);//Gouraud
	glMatrixMode(GL_MODELVIEW);

	// modelo de iluminacao simples
	//habilitar  a determnacao de iluminacao
    glEnable ( GL_LIGHTING );
	
	//iniciamos de dia
    glLightModelfv	( GL_LIGHT_MODEL_AMBIENT, ambient_light );
    glLightfv		(GL_LIGHT0,GL_DIFFUSE, source_light );
	glLightfv		(GL_LIGHT0,GL_SPECULAR, spec_light);


    glLightfv ( GL_LIGHT0,GL_POSITION, light_pos  );

    glLightf(GL_LIGHT0,GL_SPOT_CUTOFF,50);
    //glLightf(GL_LIGHT0,GL_SPOT_EXPONENT,30);
    //glLightf(GL_LIGHT0,GL_QUADRATIC_ATTENUATION,30);

    //habilitar fonte de luz
	glEnable  ( GL_LIGHT0 );
	glEnable  ( GL_LIGHT1 );

   // Enable de las propiedades del material para la iluminacin
    glEnable ( GL_COLOR_MATERIAL );
    glColorMaterial ( GL_FRONT, GL_AMBIENT_AND_DIFFUSE );

	glDepthFunc(GL_LEQUAL);
	glEnable(GL_DEPTH_TEST);
	//glClearDepth(1.0);
	glEnable ( GL_CULL_FACE );

	glColor3f (1.0, 1.0, 1.0);

	glLoadIdentity();
	glTranslatef(0, 0, -50); //z PARA ATRAS

	Table.list =1;	//id 
	NaveA.large=2;	//id
	NaveB.large=3;	//id
	NaveC.large=4;	//id

	//PARA facilitar notacao 0,1 por 1,2; 0,1,2,3 por 1,2,3,4 ...
	NaveA.large++;
	NaveB.large++;
	NaveC.large++;

	Scene.gliRotX = 0;
	Scene.gliRotY = 0;
	Scene.gliRotZ = 0;
	Scene.gliZoom = 1;

	

		//displaylist
	DisplayListTable(N,sizeItem); 
	DisplayListNaveA();//2
	DisplayListNaveB();//3
	DisplayListNaveC();//4
	DisplayListGlobe();//5
	DisplayListJet();//6
	DisplayTower();//7
	
	
	
	
	posY=0;
	Table.dItem1=0;
	Table.dItem2=0;
	Table.dItem3=0;
	Table.aItem1=0;
	Table.aItem2=0;
	Table.aItem3=0;
	
//	glRotatef(-55, 1, 0, 0);  
//	glRotatef(2, 0, 1, 0);  
	
}

void Fire(int i,int j)
{

if ( (i==NaveA.position[0][0]) && ( (j==NaveA.position[0][1]) || (j==NaveA.position[1][1]) ) ) {

    if(Table.aItem1==0){
      if( Table.table[NaveA.position[0][0]][NaveA.position[0][1]]==2 || Table.table[NaveA.position[1][0]][NaveA.position[1][1]]==2){
         Table.table[i][j]=NaveA.large;
         if(Table.table[i][NaveA.position[0][1]]==2) Table.table[i][NaveA.position[0][1]]=NaveA.large;
         else Table.table[i][NaveA.position[1][1]]=NaveA.large;
         Table.aItem1=1;
      }
      else 
		  Table.table[i][j]=2;
      flagKeyY=0;
      return;
    }
    else {
      flagKeyY=0;
      return;
    }
}

if ( i==NaveB.position[0][0] && (j==NaveB.position[0][1] || j==NaveB.position[1][1] || j==NaveB.position[2][1])) {
    if(Table.aItem2==0){
      if(j==NaveB.position[0][1]){
        if(Table.table[i][NaveB.position[1][1]]==2 && Table.table[i][NaveB.position[2][1]]==2){ //afundou
          Table.table[i][j]=NaveB.large;
          Table.table[i][NaveB.position[1][1]]=NaveB.large;
          Table.table[i][NaveB.position[2][1]]=NaveB.large;
          Table.aItem2=1;
        }
        else Table.table[i][j]=2;
      }
      if(j==NaveB.position[1][1]){
        if(Table.table[i][NaveB.position[0][1]]==2 && Table.table[i][NaveB.position[2][1]]==2){ //afundou
          Table.table[i][j]=NaveB.large;
          Table.table[i][NaveB.position[0][1]]=NaveB.large;
          Table.table[i][NaveB.position[2][1]]=NaveB.large;
          Table.aItem2=1;
        }
        else Table.table[i][j]=2;
      }
      if(j==NaveB.position[2][1]){
        if(Table.table[i][NaveB.position[1][1]]==2 && Table.table[i][NaveB.position[0][1]]==2){ //afundou
          Table.table[i][j]=NaveB.large;
          Table.table[i][NaveB.position[0][1]]=NaveB.large;
          Table.table[i][NaveB.position[1][1]]=NaveB.large;
          Table.aItem2=1;
        }
        else Table.table[i][j]=2;
      }
      flagKeyY=0;
      return;
    }
    else {
      flagKeyY=0;
      return;
    }
}



if ( i==NaveC.position[0][0] && (j==NaveC.position[0][1] || j==NaveC.position[1][1] || j==NaveC.position[2][1] || j==NaveC.position[3][1]) ) {
 if(Table.aItem3==0){
      if(j==NaveC.position[0][1]){
        if(Table.table[i][NaveC.position[1][1]]==2 && Table.table[i][NaveC.position[2][1]]==2 && Table.table[i][NaveC.position[3][1]]==2){ //afundou
          Table.table[i][j]=NaveC.large;
          Table.table[i][NaveC.position[1][1]]=NaveC.large;
          Table.table[i][NaveC.position[2][1]]=NaveC.large;
          Table.table[i][NaveC.position[3][1]]=NaveC.large;
          Table.aItem3=1;
        }
        else Table.table[i][j]=2;
      }
      if(j==NaveC.position[1][1]){
        if(Table.table[i][NaveC.position[0][1]]==2 && Table.table[i][NaveC.position[2][1]]==2 && Table.table[i][NaveC.position[3][1]]==2){ //afundou
          Table.table[i][j]=NaveC.large;
          Table.table[i][NaveC.position[0][1]]=NaveC.large;
          Table.table[i][NaveC.position[2][1]]=NaveC.large;
          Table.table[i][NaveC.position[3][1]]=NaveC.large;
          Table.aItem3=1;
        }
        else Table.table[i][j]=2;
      }
      if(j==NaveC.position[2][1]){
        if(Table.table[i][NaveC.position[0][1]]==2 && Table.table[i][NaveC.position[1][1]]==2 && Table.table[i][NaveC.position[3][1]]==2){ //afundou
          Table.table[i][j]=NaveC.large;
          Table.table[i][NaveC.position[0][1]]=NaveC.large;
          Table.table[i][NaveC.position[1][1]]=NaveC.large;
          Table.table[i][NaveC.position[3][1]]=NaveC.large;
          Table.aItem3=1;
        }
        else Table.table[i][j]=2;
      }
      if(j==NaveC.position[3][1]){
        if(Table.table[i][NaveC.position[0][1]]==2 && Table.table[i][NaveC.position[1][1]]==2 && Table.table[i][NaveC.position[2][1]]==2){ //afundou
          Table.table[i][j]=NaveB.large;
          Table.table[i][NaveC.position[0][1]]=NaveC.large;
          Table.table[i][NaveC.position[1][1]]=NaveC.large;
          Table.table[i][NaveC.position[2][1]]=NaveC.large;
          Table.aItem3=1;
        }
        else Table.table[i][j]=2;
      }
      flagKeyY=0;
      return;
    }
    else {
      flagKeyY=0;
      return;
    }
}


Table.table[i][j]=1;
flagKeyY=0;
}


void SystemCoordenateGame(int x0,int y0,float *x,float *y)
{	
	*y=( initSC-x0*sizeItem);
	*x=(-initSC+y0*sizeItem);
}

void DisplayNight(void)
{
	glEnable  ( GL_LIGHT1 );
	glLightModelfv	(GL_LIGHT_MODEL_AMBIENT, ambient_light_n );
    glLightfv		(GL_LIGHT0,GL_DIFFUSE, source_light_n );
	glLightfv		(GL_LIGHT0,GL_SPECULAR, spec_light_n);
}

void DisplayDay(void)
{
	glDisable  ( GL_LIGHT1 );
	glLightModelfv	(GL_LIGHT_MODEL_AMBIENT, ambient_light );
    glLightfv		(GL_LIGHT0,GL_DIFFUSE, source_light );
	glLightfv		(GL_LIGHT0,GL_SPECULAR, spec_light);
}
void DisplayMain(void)
{
//	glClearDepth(1.0);
  //  glClear (GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);//limpa buffers 
	//glClear (GL_COLOR_BUFFER_BIT);

   if ( Scene.gliRotX >= 360 || Scene.gliRotX <= -360)
      Scene.gliRotX= 0;
   if ( Scene.gliRotY >= 360 || Scene.gliRotY <= -360 )
      Scene.gliRotY= 0;
   if ( Scene.gliRotZ >= 360 || Scene.gliRotZ <= -360)
      Scene.gliRotZ= 0;

	glRotatef(Scene.gliRotX, 1, 0, 0);
	glRotatef(Scene.gliRotY, 0, 1, 0);
	glRotatef(Scene.gliRotZ, 0, 0, 1);
	glScalef(Scene.gliZoom, Scene.gliZoom, Scene.gliZoom);
	
	glCallList(Table.list);// desenha a tabela

	int i,j;
	float x1,x2,y1,y2;
	for(i=0;i<10;i++)
	{
     Table.dItem1=0;
     Table.dItem2=0;
     Table.dItem3=0;
     for(j=0;j<10;j++){
          // Agua 1
          if(Table.table[i][j]==1)
		  {
			  glColor3f(0.73,1,0.74);			  
			  SystemCoordenateGame(i,j,&x1,&y1);
			  SystemCoordenateGame(i+1,j+1,&x2,&y2);
			  
			  //
			  glBegin(GL_QUADS);			
				glVertex3f(x2-sizeItem,y2,0);			
				glVertex3f(x2,y2,0);				
				glVertex3f(x1+sizeItem,y1,0);
				glVertex3f(x1,y1,0);				
			  glEnd();		
			  /**/
          }
          //Nave atirada 2
          if(Table.table[i][j]==2)
		  {
			  glColor3f(1,0.2,0);
			  SystemCoordenateGame(i,j,&x1,&y1);
			  SystemCoordenateGame(i+1,j+1,&x2,&y2);
			  glPushMatrix();			  
			  glTranslatef(x1+sizeItem/2,y1-sizeItem/2,2);
			  glutSolidCube(sizeItem);
			  glPopMatrix();
          }

		  glColor3f(1,1,1);
          // BINGO NaveA 
          if(Table.table[i][j]==NaveA.large)
		  {
			  if(Table.dItem1) 
				  continue;
			  if(i<=4) 
				  y2=sizeItem*(4-i);
			  else 
				  y2=sizeItem*(-i+4);           
          	  if(j<=4) 
				  x2=-sizeItem*(4-j);
			  else 
				  x2=sizeItem*(j-4);

			  glPushMatrix();
			  glTranslatef(x2,y2,0);
				  glTranslatef(-0.4,1,0);
				  glScalef(0.25,0.25,0.25);
				  glCallList(NaveA.large-1);
			  glPopMatrix();
			  Table.dItem1=1;
          }
		  // BINGO NaveB 
          if(Table.table[i][j]==NaveB.large)
		  {
			  if(Table.dItem2)
				  continue;
			  if(i<=4) 
				y2=sizeItem*(4-i);
			  else 
				y2=sizeItem*(-i+4);           
			  
					  
			  if(j<=4) 
				x2=-sizeItem*(4-j);
			  else 
				x2=sizeItem*(-4+j);
		  
          glPushMatrix();
			  glTranslatef(x2,y2,0);          
			  glTranslatef(1.2,1,-2.5);
			  glScalef(0.5,0.25,0.25);
			  glCallList(NaveB.large-1);
          glPopMatrix();
          Table.dItem2=1;
          }
		  // BINGO NaveC
          if(Table.table[i][j]==NaveC.large)
		  {
          if(Table.dItem2) 
			  continue;
          y2=sizeItem*(4-i);          
          if(j<=4) 
			  x2=-sizeItem*(4-j);
          else
			  x2=-sizeItem*(-4+j);
          glPushMatrix();
			  glTranslatef(x2,y2,0);          
			  glTranslatef(4.4,1,-2.5);
			  glScalef(0.6,0.25,0.25);
			  glCallList(NaveC.large-1);
		  glPopMatrix();
          Table.dItem2=1;
          }
     }
   }

   /*
   glColor3f(0,0.45,1);			
   //ondas
   for(i=0;i<N;i++)
	   for(j=0;j<N;j++)
	   {
		   SystemCoordenateGame(i,j,&x1,&y1);
		   SystemCoordenateGame(i+1,j+1,&x2,&y2);
		   
		   glBegin(GL_TRIANGLES);			
				glVertex3f(x1,y1,0);
				glVertex3f(x2,y2,0);
				glVertex3f(x1,y1,random(0,sizeItem)/5);

				glVertex3f(x1,y1,0);
				glVertex3f(x2,y2,0);
				glVertex3f(x2,y2,random(0,sizeItem)/5);

				glVertex3f(x1,y1,0);
				glVertex3f(x2,y2,0);
				glVertex3f((x1+x2)/2,(y1+y2)/2,random(0,sizeItem)/5);	 
				
			  glEnd();	
	   }
	/**/
	glColor3f(1,1,1);
	
	//glutSwapBuffers();
}

void ReShape (int w, int h)
{
  if(!h) //h noa pode ser 0
	h=1;
  glViewport(0, 0, (GLsizei)w, (GLsizei)h);//ajusta o campo de visao
  glMatrixMode(GL_PROJECTION);//muda para a matriz de projecao
  glLoadIdentity();
  gluPerspective(60.0, (GLfloat)w/(GLfloat)h, 1.0, 100.0);
  glMatrixMode(GL_MODELVIEW);
  
}


void Keyboard (unsigned char key, int x, int y)
{
/*	if(key=='q' || key=='w'|| key=='e'|| key=='r'|| key=='t'|| key=='y'|| key=='u'|| key=='i'|| key=='o'|| key=='p')
	{
		posY= key -112 ;
		flagKeyY=1;			
	}else 

*/

	if(key>='0' && key<='9')
	{
		if(flagKeyY)
		{
			posX=key-48;
			Fire(posY,posX);
			printf("Posicao j :-> %i \n", posX);
		}
		else
		{
			posY= key-48;
			flagKeyY=1;
			printf("\nPosicao i :-> %i\n", posY);
		}
	}else
	
		switch (tolower(key)) 
		{
		case 32:	/*centrado (revisar)*/
  			Scene.gliRotX= 0;
			Scene.gliRotY= 0;
			Scene.gliRotZ= 0;
			Scene.gliZoom= 1;
 			break;		
		case 'x':	
			Scene.gliRotX++;		
			break;
		case 'y':
			Scene.gliRotY++;		
			break;
		case 'z':
			Scene.gliRotZ++;		
			break;
		case '+':
			Scene.gliZoom++;		
			break;
		case '-':
			Scene.gliZoom--;		
			break;	
		case 27:
			exit(0);
			break;
	  case 'k':
         glTranslatef(0,0,1);
         break;
	  case 'l':
         glTranslatef(0,0,-1);
		 break;
	  case 'o':/*esq x*/
         glTranslatef(-1,0,0);
		 break;
	  case 'i':/*dire x*/
         glTranslatef(1,0,0);
		 break;
	  case 'h':/*down y */
         glTranslatef(0,-1,0);
		 break;
	  case 'j':/*up y */
         glTranslatef(0,+1,0);
		 break;
	case 'd':/*dia*/
		DisplayDay();
	break;
	case 'n':/*dia*/
		DisplayNight();  
	break;
		 
		default:		
			break;

		}


	glutPostRedisplay();	
}

void IdleFunc ( void )
{
   //Scene.gliRotY= Scene.gliRotY+ 0.01;
   glutPostRedisplay ( );   
}


int main(int argc, char** argv)
{
   init ();
   printf("BATALHA NAVAL v0.1\n");
   if(argc>1)
   {
	   initNave(argv[1]);
	   printf("Player 2: \nsite:%s\n",argv[0]);
   }
   else
   {
	   initNave("player1.bn");
		printf("Player 1\n");
   }
/*
   glutDisplayFunc	(DisplayMain);
   glutReshapeFunc	(ReShape);
   glutKeyboardFunc	(Keyboard);
   glutMouseFunc	(Mouse);
   glutMotionFunc   (Motion);
   //glutIdleFunc     ( IdleFunc );
   glutMainLoop();
/**/
   
	//Init();	
	glutDisplayFunc	(RedrawWindow);
	glutMouseFunc(Mouse);
	glutReshapeFunc(ResizeWindow);
	glutKeyboardFunc(Keyboard);
	glutMainLoop();

   return 0;
}

