/*
PROJETO: Game OPENGL "Batalha Naval"
Author	: Roger Larico Chavez
RA		: 022693

  FEEC UNICAMP
*/
#include "stdafx.h"//tirar se esta en linux

#include "glut.h"
#include "stdlib.h"
#include "stdio.h"

#define sizeItem 4.5
#define N 10


#include "structs.h"
#include "models.h" 


//float angle, angle2,angle3;

int moving, startx, starty;
float initSC= N*sizeItem/2;

GLfloat  ambient_light[] = { 0.2, 0.2, 0.2, 1.0}; 
GLfloat   source_light[] = { 1.0, 1.0, 1.0, 1.0}; 
GLfloat     spec_light[] = { 1.0, 1.0, 1.0, 1.0};
GLfloat      light_pos[] = { 0, 25, 0, 1};//pontual

GLfloat  ambient_light_n []	= { 0.0, 0.0, 0.0, 1.0 }; 
GLfloat   source_light_n []	= { 0.2, 0.2, 0.2, 1.0 }; 
GLfloat     spec_light_n []	= { 1.0, 1.0, 1.0, 1.0};




void Mouse ( int button, int state, int x, int y )
{
   if ( button == GLUT_LEFT_BUTTON && state == GLUT_DOWN )
   {
      moving = 1;
      startx = x;
      starty = y;
   }

   if ( button == GLUT_LEFT_BUTTON && state == GLUT_UP  )
      moving = 0;
   	printf("mouse (x,y)->(%i , %i)\n",x,y);
}

void Motion ( int x, int y )
{
   if ( moving )
   {
      Scene.gliRotY= Scene.gliRotY+   ( x - startx )*0.01;
      Scene.gliRotX = Scene.gliRotX+ ( y - starty )*0.01;
      startx = x;
      starty = y;
      glutPostRedisplay ( );
   }
   
}

void initNave(char *filePath)
{
	
	FILE *stream;
	stream = fopen( filePath, "r" );
	fseek( stream, 0L, SEEK_SET );

	fscanf( stream, "%i", &NaveA.position[0][0]);	fscanf( stream, "%i", &NaveA.position[0][1]);
	fscanf( stream, "%i", &NaveA.position[1][0]);	fscanf( stream, "%i", &NaveA.position[1][1]);

	fscanf( stream, "%i", &NaveB.position[0][0]);	fscanf( stream, "%i", &NaveB.position[0][1]);
	fscanf( stream, "%i", &NaveB.position[1][0]);	fscanf( stream, "%i", &NaveB.position[1][1]);
	fscanf( stream, "%i", &NaveB.position[2][0]);	fscanf( stream, "%i", &NaveB.position[2][1]);

	fscanf( stream, "%i",&NaveC.position[0][0]);	fscanf( stream, "%i",&NaveC.position[0][1]);
	fscanf( stream, "%i",&NaveC.position[1][0]);	fscanf( stream, "%i",&NaveC.position[1][1]);
	fscanf( stream, "%i",&NaveC.position[2][0]);	fscanf( stream, "%i",&NaveC.position[2][1]);
	fscanf( stream, "%i",&NaveC.position[3][0]);	fscanf( stream, "%i",&NaveC.position[3][1]);

	fclose(stream);
}

void init(void)
{
	glutInitDisplayMode (GLUT_DOUBLE | GLUT_RGB);
	glutInitWindowSize (600, 400);
	glutInitWindowPosition (200, 0);
	glutCreateWindow ("BATALHA NAVAL 0.2");
	//glClearColor (1.0, 1.0, 1.0, 1.0); //fundo branco
	//glPolygonMode(GL_FRONT_AND_BACK, GL_LINE); //wireframe
	glShadeModel (GL_SMOOTH);//Gouraud
	glMatrixMode(GL_MODELVIEW);

	// modelo de iluminacao simples
	//habilitar  a determnacao de iluminacao
    glEnable ( GL_LIGHTING );
	
	//iniciamos de dia
    glLightModelfv	( GL_LIGHT_MODEL_AMBIENT, ambient_light );
    glLightfv		(GL_LIGHT0,GL_DIFFUSE, source_light );
	glLightfv		(GL_LIGHT0,GL_SPECULAR, spec_light);


    glLightfv ( GL_LIGHT0,GL_POSITION, light_pos  );

    glLightf(GL_LIGHT0,GL_SPOT_CUTOFF,50);
    //glLightf(GL_LIGHT0,GL_SPOT_EXPONENT,30);
    //glLightf(GL_LIGHT0,GL_QUADRATIC_ATTENUATION,30);

    //habilitar fonte de luz
	glEnable  ( GL_LIGHT0 );
	glEnable  ( GL_LIGHT1 );

   // Enable de las propiedades del material para la iluminacin
    glEnable ( GL_COLOR_MATERIAL );
    glColorMaterial ( GL_FRONT, GL_AMBIENT_AND_DIFFUSE );

	glDepthFunc(GL_LEQUAL);
	glEnable(GL_DEPTH_TEST);
	//glClearDepth(1.0);
	glEnable ( GL_CULL_FACE );

	glColor3f (1.0, 1.0, 1.0);

	glLoadIdentity();
	glTranslatef(0, 0, -50); //z PARA ATRAS

	Table.list =1;	//id 
	NaveA.large=2;	//id
	NaveB.large=3;	//id
	NaveC.large=4;	//id

	//PARA facilitar notacao 0,1 por 1,2; 0,1,2,3 por 1,2,3,4 ...
	NaveA.large++;
	NaveB.large++;
	NaveC.large++;

	Scene.gliRotX = 0;
	Scene.gliRotY = 0;
	Scene.gliRotZ = 0;
	Scene.gliZoom = 1;

	

		//displaylist
	DisplayListTable(N,sizeItem); 
	DisplayListNaveA();//2
	DisplayListNaveB();//3
	DisplayListNaveC();//4
	DisplayListGlobe();//5
	DisplayListJet();//6
	DisplayTower();//7
	
	
	
	
	posY=0;
	Table.dItem1=0;
	Table.dItem2=0;
	Table.dItem3=0;
	Table.aItem1=0;
	Table.aItem2=0;
	Table.aItem3=0;
	
	glRotatef(-55, 1, 0, 0);  
	glRotatef(2, 0, 1, 0);  
	
}

void Fire(int i,int j){

if ( (i==NaveA.position[0][0]) && ( (j==NaveA.position[0][1]) || (j==NaveA.position[1][1]) ) ) {

    if(Table.aItem1==0){
      if( Table.table[NaveA.position[0][0]][NaveA.position[0][1]]==2 || Table.table[NaveA.position[1][0]][NaveA.position[1][1]]==2){
         Table.table[i][j]=NaveA.large;
         if(Table.table[i][NaveA.position[0][1]]==2) Table.table[i][NaveA.position[0][1]]=NaveA.large;
         else Table.table[i][NaveA.position[1][1]]=NaveA.large;
         Table.aItem1=1;
      }
      else 
		  Table.table[i][j]=2;
      flagKeyY=0;
      return;
    }
    else {
      flagKeyY=0;
      return;
    }
}

if ( i==NaveB.position[0][0] && (j==NaveB.position[0][1] || j==NaveB.position[1][1] || j==NaveB.position[2][1])) {
    if(Table.aItem2==0){
      if(j==NaveB.position[0][1]){
        if(Table.table[i][NaveB.position[1][1]]==2 && Table.table[i][NaveB.position[2][1]]==2){ //afundou
          Table.table[i][j]=NaveB.large;
          Table.table[i][NaveB.position[1][1]]=NaveB.large;
          Table.table[i][NaveB.position[2][1]]=NaveB.large;
          Table.aItem2=1;
        }
        else Table.table[i][j]=2;
      }
      if(j==NaveB.position[1][1]){
        if(Table.table[i][NaveB.position[0][1]]==2 && Table.table[i][NaveB.position[2][1]]==2){ //afundou
          Table.table[i][j]=NaveB.large;
          Table.table[i][NaveB.position[0][1]]=NaveB.large;
          Table.table[i][NaveB.position[2][1]]=NaveB.large;
          Table.aItem2=1;
        }
        else Table.table[i][j]=2;
      }
      if(j==NaveB.position[2][1]){
        if(Table.table[i][NaveB.position[1][1]]==2 && Table.table[i][NaveB.position[0][1]]==2){ //afundou
          Table.table[i][j]=NaveB.large;
          Table.table[i][NaveB.position[0][1]]=NaveB.large;
          Table.table[i][NaveB.position[1][1]]=NaveB.large;
          Table.aItem2=1;
        }
        else Table.table[i][j]=2;
      }
      flagKeyY=0;
      return;
    }
    else {
      flagKeyY=0;
      return;
    }
}



if ( i==NaveC.position[0][0] && (j==NaveC.position[0][1] || j==NaveC.position[1][1] || j==NaveC.position[2][1] || j==NaveC.position[3][1]) ) {
 if(Table.aItem3==0){
      if(j==NaveC.position[0][1]){
        if(Table.table[i][NaveC.position[1][1]]==2 && Table.table[i][NaveC.position[2][1]]==2 && Table.table[i][NaveC.position[3][1]]==2){ //afundou
          Table.table[i][j]=NaveC.large;
          Table.table[i][NaveC.position[1][1]]=NaveC.large;
          Table.table[i][NaveC.position[2][1]]=NaveC.large;
          Table.table[i][NaveC.position[3][1]]=NaveC.large;
          Table.aItem3=1;
        }
        else Table.table[i][j]=2;
      }
      if(j==NaveC.position[1][1]){
        if(Table.table[i][NaveC.position[0][1]]==2 && Table.table[i][NaveC.position[2][1]]==2 && Table.table[i][NaveC.position[3][1]]==2){ //afundou
          Table.table[i][j]=NaveC.large;
          Table.table[i][NaveC.position[0][1]]=NaveC.large;
          Table.table[i][NaveC.position[2][1]]=NaveC.large;
          Table.table[i][NaveC.position[3][1]]=NaveC.large;
          Table.aItem3=1;
        }
        else Table.table[i][j]=2;
      }
      if(j==NaveC.position[2][1]){
        if(Table.table[i][NaveC.position[0][1]]==2 && Table.table[i][NaveC.position[1][1]]==2 && Table.table[i][NaveC.position[3][1]]==2){ //afundou
          Table.table[i][j]=NaveC.large;
          Table.table[i][NaveC.position[0][1]]=NaveC.large;
          Table.table[i][NaveC.position[1][1]]=NaveC.large;
          Table.table[i][NaveC.position[3][1]]=NaveC.large;
          Table.aItem3=1;
        }
        else Table.table[i][j]=2;
      }
      if(j==NaveC.position[3][1]){
        if(Table.table[i][NaveC.position[0][1]]==2 && Table.table[i][NaveC.position[1][1]]==2 && Table.table[i][NaveC.position[2][1]]==2){ //afundou
          Table.table[i][j]=NaveB.large;
          Table.table[i][NaveC.position[0][1]]=NaveC.large;
          Table.table[i][NaveC.position[1][1]]=NaveC.large;
          Table.table[i][NaveC.position[2][1]]=NaveC.large;
          Table.aItem3=1;
        }
        else Table.table[i][j]=2;
      }
      flagKeyY=0;
      return;
    }
    else {
      flagKeyY=0;
      return;
    }
}


Table.table[i][j]=1;
flagKeyY=0;
}


void SystemCoordenateGame(int x0,int y0,float *x,float *y)
{	
	*y=( initSC-x0*sizeItem);
	*x=(-initSC+y0*sizeItem);
}

void DisplayNight(void)
{
	glEnable  ( GL_LIGHT1 );
	glLightModelfv	(GL_LIGHT_MODEL_AMBIENT, ambient_light_n );
    glLightfv		(GL_LIGHT0,GL_DIFFUSE, source_light_n );
	glLightfv		(GL_LIGHT0,GL_SPECULAR, spec_light_n);
}

void DisplayDay(void)
{
	glDisable  ( GL_LIGHT1 );
	glLightModelfv	(GL_LIGHT_MODEL_AMBIENT, ambient_light );
    glLightfv		(GL_LIGHT0,GL_DIFFUSE, source_light );
	glLightfv		(GL_LIGHT0,GL_SPECULAR, spec_light);
}
void DisplayMain(void)
{
	glClearDepth(1.0);
    glClear (GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);//limpa buffers 
	//glClear (GL_COLOR_BUFFER_BIT);

   if ( Scene.gliRotX >= 360 || Scene.gliRotX <= -360)
      Scene.gliRotX= 0;
   if ( Scene.gliRotY >= 360 || Scene.gliRotY <= -360 )
      Scene.gliRotY= 0;
   if ( Scene.gliRotZ >= 360 || Scene.gliRotZ <= -360)
      Scene.gliRotZ= 0;

	glRotatef(Scene.gliRotX, 1, 0, 0);
	glRotatef(Scene.gliRotY, 0, 1, 0);
	glRotatef(Scene.gliRotZ, 0, 0, 1);
	glScalef(Scene.gliZoom, Scene.gliZoom, Scene.gliZoom);
	
	glCallList(Table.list);// desenha a tabela

	int i,j;
	float x1,x2,y1,y2;
	for(i=0;i<10;i++)
	{
     Table.dItem1=0;
     Table.dItem2=0;
     Table.dItem3=0;
     for(j=0;j<10;j++){
          // Agua 1
          if(Table.table[i][j]==1)
		  {
			  glColor3f(0.73,1,0.74);			  
			  SystemCoordenateGame(i,j,&x1,&y1);
			  SystemCoordenateGame(i+1,j+1,&x2,&y2);
			  
			  //
			  glBegin(GL_QUADS);			
				glVertex3f(x2-sizeItem,y2,0);			
				glVertex3f(x2,y2,0);				
				glVertex3f(x1+sizeItem,y1,0);
				glVertex3f(x1,y1,0);				
			  glEnd();		
			  /**/
          }
          //Nave atirada 2
          if(Table.table[i][j]==2)
		  {
			  glColor3f(1,0.2,0);
			  SystemCoordenateGame(i,j,&x1,&y1);
			  SystemCoordenateGame(i+1,j+1,&x2,&y2);
			  glPushMatrix();			  
			  glTranslatef(x1+sizeItem/2,y1-sizeItem/2,2);
			  glutSolidCube(sizeItem);
			  glPopMatrix();
          }

		  glColor3f(1,1,1);
          // BINGO NaveA 
          if(Table.table[i][j]==NaveA.large)
		  {
			  if(Table.dItem1) 
				  continue;
			  if(i<=4) 
				  y2=sizeItem*(4-i);
			  else 
				  y2=sizeItem*(-i+4);           
          	  if(j<=4) 
				  x2=-sizeItem*(4-j);
			  else 
				  x2=sizeItem*(j-4);

			  glPushMatrix();
			  glTranslatef(x2,y2,0);
				  glTranslatef(-0.4,1,0);
				  glScalef(0.25,0.25,0.25);
				  glCallList(NaveA.large-1);
			  glPopMatrix();
			  Table.dItem1=1;
          }
		  // BINGO NaveB 
          if(Table.table[i][j]==NaveB.large)
		  {
			  if(Table.dItem2)
				  continue;
			  if(i<=4) 
				y2=sizeItem*(4-i);
			  else 
				y2=sizeItem*(-i+4);           
			  
					  
			  if(j<=4) 
				x2=-sizeItem*(4-j);
			  else 
				x2=sizeItem*(-4+j);
		  
          glPushMatrix();
			  glTranslatef(x2,y2,0);          
			  glTranslatef(1.2,1,-2.5);
			  glScalef(0.5,0.25,0.25);
			  glCallList(NaveB.large-1);
          glPopMatrix();
          Table.dItem2=1;
          }
		  // BINGO NaveC
          if(Table.table[i][j]==NaveC.large)
		  {
          if(Table.dItem2) 
			  continue;
          y2=sizeItem*(4-i);          
          if(j<=4) 
			  x2=-sizeItem*(4-j);
          else
			  x2=-sizeItem*(-4+j);
          glPushMatrix();
			  glTranslatef(x2,y2,0);          
			  glTranslatef(4.4,1,-2.5);
			  glScalef(0.6,0.25,0.25);
			  glCallList(NaveC.large-1);
		  glPopMatrix();
          Table.dItem2=1;
          }
     }
   }

   /*
   glColor3f(0,0.45,1);			
   //ondas
   for(i=0;i<N;i++)
	   for(j=0;j<N;j++)
	   {
		   SystemCoordenateGame(i,j,&x1,&y1);
		   SystemCoordenateGame(i+1,j+1,&x2,&y2);
		   
		   glBegin(GL_TRIANGLES);			
				glVertex3f(x1,y1,0);
				glVertex3f(x2,y2,0);
				glVertex3f(x1,y1,random(0,sizeItem)/5);

				glVertex3f(x1,y1,0);
				glVertex3f(x2,y2,0);
				glVertex3f(x2,y2,random(0,sizeItem)/5);

				glVertex3f(x1,y1,0);
				glVertex3f(x2,y2,0);
				glVertex3f((x1+x2)/2,(y1+y2)/2,random(0,sizeItem)/5);	 
				
			  glEnd();	
	   }
	/**/
	glColor3f(1,1,1);
	
	glutSwapBuffers();
}

void ReShape (int w, int h)
{
  if(!h) //h noa pode ser 0
	h=1;
  glViewport(0, 0, (GLsizei)w, (GLsizei)h);//ajusta o campo de visao
  glMatrixMode(GL_PROJECTION);//muda para a matriz de projecao
  glLoadIdentity();
  gluPerspective(60.0, (GLfloat)w/(GLfloat)h, 1.0, 100.0);
  glMatrixMode(GL_MODELVIEW);
  
}


void Keyboard (unsigned char key, int x, int y)
{
/*	if(key=='q' || key=='w'|| key=='e'|| key=='r'|| key=='t'|| key=='y'|| key=='u'|| key=='i'|| key=='o'|| key=='p')
	{
		posY= key -112 ;
		flagKeyY=1;			
	}else 

*/

	if(key>='0' && key<='9')
	{
		if(flagKeyY)
		{
			posX=key-48;
			Fire(posY,posX);
			printf("Posicao j :-> %i \n", posX);
		}
		else
		{
			posY= key-48;
			flagKeyY=1;
			printf("\nPosicao i :-> %i\n", posY);
		}
	}else
	
		switch (tolower(key)) 
		{
		case 32:	/*centrado (revisar)*/
  			Scene.gliRotX= 0;
			Scene.gliRotY= 0;
			Scene.gliRotZ= 0;
			Scene.gliZoom= 1;
 			break;		
		case 'x':	
			Scene.gliRotX++;		
			break;
		case 'y':
			Scene.gliRotY++;		
			break;
		case 'z':
			Scene.gliRotZ++;		
			break;
		case '+':
			Scene.gliZoom++;		
			break;
		case '-':
			Scene.gliZoom--;		
			break;	
		case 27:
			exit(0);
			break;
	  case 'k':
         glTranslatef(0,0,1);
         break;
	  case 'l':
         glTranslatef(0,0,-1);
		 break;
	  case 'o':/*esq x*/
         glTranslatef(-1,0,0);
		 break;
	  case 'i':/*dire x*/
         glTranslatef(1,0,0);
		 break;
	  case 'h':/*down y */
         glTranslatef(0,-1,0);
		 break;
	  case 'j':/*up y */
         glTranslatef(0,+1,0);
		 break;
	case 'd':/*dia*/
		DisplayDay();
	break;
	case 'n':/*dia*/
		DisplayNight();  
	break;
		 
		default:		
			break;

		}


	glutPostRedisplay();	
}

void IdleFunc ( void )
{
   //Scene.gliRotY= Scene.gliRotY+ 0.01;
   glutPostRedisplay ( );   
}


int main(int argc, char** argv)
{
   init ();
   printf("BATALHA NAVAL v0.1\n");
   if(argc>1)
   {
	   initNave(argv[1]);
	   printf("Player 2: \nsite:%s\n",argv[0]);
   }
   else
   {
	   initNave("player1.bn");
		printf("Player 1\n");
   }
   glutDisplayFunc	(DisplayMain);
   glutReshapeFunc	(ReShape);
   glutKeyboardFunc	(Keyboard);
   glutMouseFunc	(Mouse);
   glutMotionFunc   (Motion);
   //glutIdleFunc     ( IdleFunc );
   glutMainLoop();
   return 0;
}

